import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.plugin.frame.*;

public class Plot_Stack implements PlugIn {

	public void run(String arg) {
		ImagePlus imp = IJ.getImage();
		int dim = imp.getNDimensions();
		if (dim == 2) {
			IJ.error("stack required");
			return;
		}
		int length = 0;
		//length
		if(dim == 3) length = imp.getImageStackSize();
		if(dim == 4) length = imp.getNFrames();
			
		Plot plot;
		ProfilePlot pp;
		// Find min and max value along the profile
		int xmin;
		int xmax;
		double ymin;
		double ymax;
		imp.setPosition(1);
		pp =  new ProfilePlot(imp);
		plot = pp.getPlot();
		//xmin = (int)plot.getLimits()[0];
		//xmax = (int)plot.getLimits()[1];
		ymin = pp.getMin();
		ymax = pp.getMax();
		
		for (int i=2; i<=length; i++) {
			if (dim == 3) imp.setPosition(i);
			if (dim == 4) imp.setPosition(1,1,i);
			pp =  new ProfilePlot(imp);
			plot = pp.getPlot();
			if (pp.getMin() < ymin) ymin = pp.getMin();
			if (pp.getMax() > ymax) ymax = pp.getMax();
		}
		
		//make a stack of profile
		Dimension size = plot.getSize();
		ImageStack stack = new ImageStack(size.width,size.height);
		for (int i=1; i<= length; i++) {
			if (dim == 3) imp.setPosition(i);
			if (dim == 4) imp.setPosition(1,1,i);
			pp =  new ProfilePlot(imp);
			pp.setMinAndMax(ymin,ymax);
			plot = pp.getPlot();
			stack.addSlice(plot.getProcessor());
		}
		ImagePlus output = new ImagePlus("profile plot",stack);
		output.show();
	}

}